#ifndef YSSHELLKDTREE_IS_INCLUDED
#define YSSHELLKDTREE_IS_INCLUDED
/* { */

class YsShell3dTree : protected Ys3dTree <YsShellVertexHandle>
{
public:
	using Ys3dTree <YsShellVertexHandle>::GetRootNode;
	using Ys3dTree <YsShellVertexHandle>::PreAllocateNode;

	YSRESULT Build(const class YsShell &shl);
	YSRESULT AddVertex(const class YsShell &shl,YsShellVertexHandle vtHd);
	YSRESULT MakeVertexList(YsArray <YsShellVertexHandle,128> &lst,const YsVec3 &min,const YsVec3 &max) const;

	inline YSRESULT ThisIsADummyFunctionAndMustNeverBeCalledButNecessaryForOmittingOneOfStupicCompilerWarnings(void);

protected:
	virtual YSRESULT Enumerate(YsKdTreeEnumParam *enumParam,const YsVec3 &pos,const YsShellVertexHandle &attrib) const;
};

inline YSRESULT YsShell3dTree::ThisIsADummyFunctionAndMustNeverBeCalledButNecessaryForOmittingOneOfStupicCompilerWarnings(void)
{
	YsVec3 pos=YsOrigin();
	YsShellVertexHandle vtHd=NULL;
	YsKdTreeEnumParam *enumParam=NULL;
	return Ys3dTree <YsShellVertexHandle>::Enumerate(enumParam,pos,vtHd);
}

/* } */
#endif
