#if (defined(_WIN32) || defined(_WIN64)) && !defined(_CRT_SECURE_NO_WARNINGS)
	// This disables annoying warnings VC++ gives for use of C standard library.  Shut the mouth up.
	#define _CRT_SECURE_NO_WARNINGS
#endif

#include "ysclass.h"

#include <stdlib.h>

YsVec2i::YsVec2i(const char *x,const char *y)
{
	dat[0]=atoi(x);
	dat[1]=atoi(y);
}

const char *YsVec2i::Text(char buf[],const char *fmt) const
{
	sprintf(buf,fmt,x(),y());
	return buf;
}

////////////////////////////////////////////////////////////

YsVec3i::YsVec3i(const char *x,const char *y,const char *z)
{
	dat[0]=atoi(x);
	dat[1]=atoi(y);
	dat[2]=atoi(z);
}

const char *YsVec3i::Text(char buf[],const char *fmt) const
{
	sprintf(buf,fmt,x(),y(),z());
	return buf;
}
