#include "fsgui3dapp.h"



void FsGui3DMainCanvas::FileOpen(void)
{
	fileDialog.Initialize();
	fileDialog.mode=FsGuiFileDialog::MODE_OPEN;
	fileDialog.defaultFileName=lastFileName;
	fileDialog.SetCloseModalCallBack(FileOpenCallBack);

	fileDialog.fileExtensionArray.Append(L".srf");
	fileDialog.fileExtensionArray.Append(L".dnm");

	AttachModalDialog(&fileDialog);
}

void FsGui3DMainCanvas::FileOpenCallBack(FsGuiControlBase *canvas,FsGuiDialog *closedDialog,int)
{
	FsGui3DMainCanvas *mainCanvas=(FsGui3DMainCanvas *)canvas;
	FsGuiFileDialog *fdlg=(FsGuiFileDialog *)closedDialog;

	if(YSOK==fdlg->res && 0<fdlg->selectedFileArray.GetN())
	{
		mainCanvas->OpenFile(fdlg->selectedFileArray[0]);
	}
}

